<template>
    <span>
        {{ text_before }}{{ reactiveValue }}{{ text_after }}
    </span>
</template>

<script>
    import { DatabaseFieldchangerEventBus } from '../DatabaseFieldchangerEventBus.js';

    export default {

        props: {
            classname: {
                type: String,
                required: true,
            },

            entity_id: {
                type: Number,
                required: true,
            },

            fieldname: {
                type: String,
                required: true,
            },

            current_value: {
                default: null,
            },

            text_before: {
                type: String,
                default: null,
            },

            text_after: {
                type: String,
                default: null,
            },
        },

        data: function () {
            return {
                reactiveValue: this.current_value
            }
        },

        methods: {
            changeValue(new_value) {
                this.reactiveValue = new_value;
            }
        },

        mounted() {
            DatabaseFieldchangerEventBus.$on(this.classname + '::' + this.entity_id + '::' + this.fieldname + '::changed', this.changeValue);
        }

    }
</script>